---
title: Information contained in a WebIDL file
slug: >-
  MDN/Contribute/Howto/Write_an_API_reference/Information_contained_in_a_WebIDL_file
tags:
  - Howto
  - MDN Meta
  - Reference
  - WebIDL
---
<div>{{MDNSidebar}}</div>

<p class="summary">When writing documentation about an API, the sources of information are many: the specifications describe what should be implemented as well as the model, and the implementations describe what has actually been put in the browsers. WebIDL files are a very condensed way of giving a lot, but not all, of the information about the API. This document provides a reference to help understand WebIDL syntax.</p>

<p>IDL stands for <em><strong>Interface Definition Language</strong></em> and it is designed to describe APIs. In the wider world of computing there are several kinds of IDL. In the world of browsers, the IDL we use is called <em>WebIDL</em>. Two kinds of WebIDL are available: the one given in the WebIDL spec, and the one implemented in browsers. The spec is the canonical reference, and the browser WebIDL describes what is actually implemented in a particular browser, and contains additional things such as annotations, information about non-standard elements, and browser-specific extensions to the IDL specification.</p>

<h2 id="Where_to_find_WebIDL_files">Where to find WebIDL files</h2>

<p>WebIDL can be found in multiple locations:</p>

<ul>
 <li>Each specification contains WebIDL inside the text: it is a very convenient way to convey precise definition. These describe the syntax of the API. Though the canonical reference, we have to keep in mind that they may differ from the actual implementation. On MDN we want to be practical and document what the Web platform really is, not what it ideally should be. So double check what is there with implementations (and don't hesitate to file bugs if you discover incoherence).</li>
 <li>Three browser engines use (modified) WebIDL as part as their toolchain: Gecko, Chromium/Blink, and WebCore/WebKit. Pre-Chromium versions of Edge used it internally, but these are unfortunately not public.
  <ul>
   <li>For Gecko, all WebIDL files are grouped in a single directory: <a href="https://dxr.mozilla.org/mozilla-central/source/dom/webidl/">https://dxr.mozilla.org/mozilla-central/source/dom/webidl/</a>. Their extension is <code>.webidl</code>. There are other <code>*.idl</code> files in the Gecko source tree but they are not WebIDL, so you can ignore them. Older versions of Gecko have some of their WebIDL scattered around somewhat, and may even use Mozilla's IDL instead of WebIDL to describe some Web interfaces, but this won't be a problem in any recent Gecko code.</li>
   <li>For Chromium, they are located in two locations, both subtrees of the source code's <code><a href="https://source.chromium.org/chromium/chromium/src/+/master:third_party/blink/renderer/">renderer/<a></a></code> directory: <code><a href="https://source.chromium.org/chromium/chromium/src/+/master:third_party/blink/renderer/core/">core/</a></code> and <code><a href="https://source.chromium.org/chromium/chromium/src/+/master:third_party/blink/renderer/modules/">modules/</a></code>. Chromium source code has IDL files in other locations, but these are part of the testing system and not relevant to API implementations.</li>
   <li>For WebCore, they are scattered around the source code, so you need to dig a bit more: E.g. <a href="https://github.com/WebKit/webkit/blob/master/Source/WebCore/html/DOMTokenList.idl">https://github.com/WebKit/webkit/blob/master/Source/WebCore/html/DOMTokenList.idl</a></li>
  </ul>
 </li>
</ul>

<h2 id="Different_dialects_of_WebIDL">Different dialects of WebIDL</h2>

<p>WebIDL is defined in <a href="https://heycam.github.io/webidl/">its specification</a>. But it has been designed to be extended to convey more information, and browser vendors have done so:</p>

<ul>
 <li>For Gecko, MDN has the <a href="/en-US/docs/Mozilla/WebIDL_bindings">documentation</a> of its dialectal WebIDL.</li>
 <li>For Chromium, Google also created a <a href="https://www.chromium.org/blink/webidl">document</a> to describe its extensions.</li>
 <li>For WebCore, Apple also made available a <a href="https://trac.webkit.org/wiki/WebKitIDL">page</a> for its dialect.</li>
</ul>

<div class="note">
<p>We describe here only the subset of WebIDL which is most useful when writing documentation. There are many more annotations useful for implementers; refer to the four documents linked above to have a complete overview.</p>
</div>

<h2 id="Interfaces">Interfaces</h2>

<p>This section explains the WebIDL syntax that describes overall API features.</p>

<h3 id="Name_of_the_interface">Name of the interface</h3>

<p>The interface name is the string that appears after the keyword <code>interface</code><em> </em>and before the next opening bracket (<code>'{'</code>) or colon (<code>':'</code>).</p>

<pre class="syntaxbox" lang="en"><strong>interface</strong> URL {};</pre>

<p>Each WebIDL interface, being a true interface or a mixin, has its own page in the documentation, listing every constructor, property and method defined for it.</p>

<h3 id="Inheritance_chain">Inheritance chain</h3>

<p>The parent, if any, of a given interface is defined after the interface name, following a colon (<code>':'</code>). There can be only one parent per interface.</p>

<pre class="syntaxbox" lang="en">interface HTMLMediaElement : <strong>HTMLElement</strong> {…}</pre>

<p><span>The inheritance chain is listed automatically in the sidebar (using the \{{APIRef}} macro). It can also be added as an SVG image via the macro \{{InheritanceDiagram}}.</span></p>

<h3 id="Mixins">Mixins</h3>

<p>Some properties or methods are available to several interfaces. To prevent redefinition they are defined in special WebIDL interfaces called <em>mixins</em>.</p>

<p>As of September 2019, mixin syntax was updated. In the new syntax, you use <code>interface mixin</code> to define a mixin interface, like so:</p>

<pre>interface MyInterface {};

interface mixin MyMixin {
  void somethingMixedIn();
}
</pre>

<p>You then use the <code>includes</code> keyword to say that the properties defined inside a mixin are available on an interface:</p>

<pre>MyInterface includes MyMixin;</pre>

<p>Mixins have no inheritance and cannot include other mixins. They do however support partials, so you will see things like this:</p>

<pre>interface MyInterface {};
interface mixin MyMixin {};

partial interface mixin MyMixin {
  void somethingMixedIn();
};

MyInterface includes MyMixin;</pre>

<p>For documentation purposes, we create a mixin page, with the same structure as an interface page. As they are not true interfaces, the word <em>interface</em> is not used — <em>mixin</em> is used instead.</p>

<p>Mixin methods and properties are listed in the same way as regular methods and properties:</p>

<ul>
 <li>They have their own pages, prefixed with the mixin name. E.g {{domxref('Body.bodyUsed')}} or {{domxref('Body.blob()')}}.</li>
 <li>They are listed on the interface page when the interface <em>implements</em> the mixin. Unlike regular properties and methods, they are prefixed with the mixin name and not the interface name. You can see <code>Body</code> properties and methods listed on both {{domxref('Request')}} and {{domxref('Response')}} interfaces, as they both implement the <code>Body</code> mixin.</li>
</ul>

<div class="notecard note">
<p><span><strong>Note:</strong> Mixin names do not appear in a Web developer console. We shouldn't show them, but we currently do this as it saves us from duplicating content, which would lead to a maintenance issue. We do this if the mixin is only used in one interface. (Such cases are bugs in the relevant specs. They shouldn't be defined as mixins, but as partial interfaces.)</span></p>
</div>

<h3 id="Old_mixin_syntax">Old mixin syntax</h3>

<p>In the old-style WebIDL mixin syntax, which you still might encounter in some places, mixins are prefixed using the <code>[NoInterfaceObject]</code> annotation:</p>

<pre class="syntaxbox" lang="en"><strong>[NoInterfaceObject]</strong>
   <strong>interface</strong> MyMixin {…}</pre>

<p>In the old-style syntax, mixins implemented on an interface are defined using the <code>implements</code> keyword.</p>

<pre class="syntaxbox" lang="en">MyInterface <strong>implements</strong> MyMixin;</pre>

<h3 id="Availability_in_window_and_workers"><span>Availability in window and workers</span></h3>

<p>Availability in Web workers (of any type) and on the Window scope is defined using an annotation: <code>[Exposed=(Window,Worker)]</code>. The annotation applies to the partial interface it is listed with.</p>

<pre class="syntaxbox" lang="en"><strong>[Exposed=(Window,Worker)]</strong>
interface Performance {
   [DependsOn=DeviceState, Affects=Nothing]<a class="l d1" href="http://mxr.mozilla.org/mozilla-central/source/dom/webidl/Performance.webidl#19">
</a>   DOMHighResTimeStamp now();
};

<strong>[Exposed=Window]</strong>
partial interface Performance {
   [Constant]
   readonly attribute PerformanceTiming timing;
   [Constant]
   readonly attribute PerformanceNavigation navigation;

   jsonifier;
};</pre>

<p>In this case <code>Performance.now()</code> is available on the <code>Window</code> scope and to any worker, while <code>Performance.timing</code>, <code>Performance.navigation</code> and <code>Performance.toJSON()</code> are not available to Web workers.</p>

<p>The most common values for the <code>[Exposed]</code> are:</p>

<dl>
 <dt><code>Window</code></dt>
 <dd>The partial interface is available to the {{domxref('Window')}} global scope.</dd>
 <dt><code>Worker</code></dt>
 <dd>The partial interface is available to any kind of worker, that is if the global scope is a descendant of {{domxref('WorkerGlobalScope')}} — {{domxref('DedicatedWorkerGlobalScope')}}, {{domxref('SharedWorkerGlobalScope')}}, or {{domxref('ServiceWorkerGlobalScope')}} (It also is available to <code>ChromeWorker</code>, but we don't document this as they are not visible on the Web and are internal to Firefox.)</dd>
 <dt><code>DedicatedWorker</code></dt>
 <dd>The partial interface is available to the {{domxref('DedicatedWorkerGlobalScope')}} only.<code> </code></dd>
 <dt><code>SharedWorker</code></dt>
 <dd>The partial interface is available to the {{domxref('SharedWorkerGlobalScope')}} only.</dd>
 <dt><code>ServiceWorker</code></dt>
 <dd>The partial interface is available to the {{domxref('ServiceWorkerGlobalScope')}} only.</dd>
</dl>

<p>Another value is possible, like <code>System</code>, but this has a <a href="/en-US/docs/Mozilla/WebIDL_bindings#Exposed">special meaning</a> and doesn't need to be documented.</p>

<p>Note that these possible values are themselves defined in WebIDL files. Interfaces may have a <code>[Global=xyz]</code> annotation. It means that when an object of this type is used as a global scope, any interface, property or method, with <code>xyz</code> as a value of <code>[Exposed]</code> is available.</p>

<pre class="syntaxbox" lang="en">[Global=(Worker,DedicatedWorker), Exposed=DedicatedWorker]
interface DedicatedWorkerGlobalScope : WorkerGlobalScope {…}</pre>

<p>Here, it is defined that when the global scope is of type <code>DedicatedWorkerGlobalScope</code>, that is if we are in a dedicated worker, any interface, property or method exposed – using the <code>[Exposed]</code> annotation – to <code>Worker</code> or <code>DedicatedWorker</code> is available.</p>

<h3 id="Preferences">Preferences</h3>

<div class="note">
<p><strong>Note:</strong> this information is specific to Gecko and should only be used in the Browser compatibility section.</p>
</div>

<p>In Gecko, the availability of a partial interface, including its constructor, properties and methods may be controlled by a preference (usually called a "pref"). This is marked in the WebIDL too.</p>

<pre class="syntaxbox" lang="en"><strong>[Pref="media.webspeech.synth.enabled"]</strong>
interface SpeechSynthesis {
   readonly attribute boolean pending;
   readonly attribute boolean speaking;
   readonly attribute boolean paused;
};</pre>

<p><span>Here <code>media.webspeech.synth.enabled</code> controls the <code>SpeechSynthesis</code> interface and its properties (the full listing has more than 3.)</span></p>

<div class="note">
<p><span><strong>Note:</strong> the default value of the preference is not available directly in the WebIDL (it can be different from one product using Gecko to another.)</span></p>
</div>

<h3 id="Available_only_in_system_code">Available only in system code</h3>

<p>Some interface features might only be available in browser internal system code, or chrome code. To signify this, in Gecko we use [ChromeOnly], for example the property propName in the following example is only callable via chrome code:</p>

<pre>interface MyInterface {
  [ChromeOnly]
  readonly attribute PropValue propName;
};</pre>

<h2 id="Properties">Properties</h2>

<p>You can recognize the definition of a property by the presence of the <code>attribute</code> keyword.</p>

<h3 id="Name_of_the_property">Name of the property</h3>

<pre class="syntaxbox" lang="en">readonly attribute MediaError? <strong>error</strong>;</pre>

<p>In the above example the name of the property is <code>error</code>; in the docs we will refer to it as <code>HTMLMediaElement.error</code> as it belongs to the <code>HTMLMediaElement</code> interface. Linking to the page is either done <strong>with</strong> the interface prefix using \{{domxref('HTMLMediaElement.error')}} or <strong>without</strong> the prefix using \{{domxref('HTMLMediaElement.error', 'error')}} when the context is obvious and unambiguous.</p>

<h3 id="Type_of_the_property">Type of the property</h3>

<pre class="syntaxbox">readonly attribute <strong>MediaError?</strong> error;</pre>

<p><span>The property value is an object of type <code>MediaError</code>. The question mark (<code>'?'</code>) indicates that it can take a value of <code>null</code>, and the documentation must explain <em>when</em> this may occur. If no question mark is present, the <code>error</code> property can't be <code>null</code>.</span></p>

<h3 id="Writing_permissions_on_the_property"><span>Writing permissions on the property</span></h3>

<pre class="syntaxbox"><strong>readonly</strong> attribute MediaError? error;</pre>

<p><span>If the keyword <code>readonly</code> is present, the property can't be modified. It must be marked as read-only:</span></p>

<ul>
 <li><span>In the interface, by adding the \{{ReadOnlyInline}} macro next to its definition term.</span></li>
 <li><span>In the first sentence of its own page, by starting the description with: <em>The read-only <code><strong>HTMLMediaElement.error</strong></code> property…</em></span></li>
 <li><span>By adding the <code>Read-only</code> tag to its own page.</span></li>
 <li><span>By starting its description in the interface page with <em>Returns…</em></span></li>
</ul>

<div class="note">
<p><span><em><strong>Note:</strong> Only read-only properties can be described as 'returning' a value. Non read-only properties can also be used to set a value.</em></span></p>
</div>

<ul>
</ul>

<h3 id="Throwing_exceptions">Throwing exceptions</h3>

<pre class="syntaxbox" lang="en"><strong>[SetterThrows]</strong>
            attribute DOMString src;</pre>

<p><span>In some cases, like when some values are illegal, setting a new value can lead to an exception being raised. This is marked using the <code>[SetterThrows]</code> annotation. When this happens, the Syntax section of the property page <em>must</em> have an Exceptions subsection. The list of exceptions and the conditions to have them thrown are listed, as textual information, in the specification of that API.</span></p>

<p><span>Note that some exceptions are not explicitly marked but are defined by the JavaScript bindings. <a href="https://heycam.github.io/webidl/#es-enumeration">Trying to set an illegal enumerated value</a> (mapped to a JavaScript {{jsxref('String')}}) raises a {{exception('TypeError')}} exception. This must be documented, but is only implicitly marked in the WebIDL document.</span></p>

<p><span>It is uncommon to have getters throwing exceptions, though it happens in a few cases. In this case the <code>[GetterThrows]</code> annotation is used. Here also, the Syntax section of the property page <em>must</em> have an Exceptions subsection.</span></p>

<pre class="syntaxbox"><code id="line-16">partial interface Blob {</code><code id="line-17">
</code><code id="line-18">  <strong>[GetterThrows]</strong>
</code><code id="line-19">  readonly attribute <span class="k">unsigned</span> <span class="k">long</span> <span class="k">long</span> size;
};</code>
</pre>

<h3 id="Not_throwing_exceptions">Not throwing exceptions</h3>

<p>When the semantics of Webidl is not followed, an exception is often thrown, even without <code>[SetterThrows]</code> or <code>[GetterThrows]</code> set. For example, in strict mode, if we try to set a read-only property to a new value, that is to call its implicit setter, a read-only property will throw in strict mode.</p>

<p>Mostly for compatibility purpose, this behavior is sometimes annoying. To prevent this by creating a no-op setter (that is by silently ignoring any attempt to set the property to a new value), the <code>[LenientSetter]</code> annotation can be used.</p>

<pre class="syntaxbox"><code id="line-223">partial interface Document {</code><code id="line-225"><span class="c">
</span></code><code id="line-226"><strong>  [LenientSetter]</strong>
</code><code id="line-227">  readonly attribute boolean fullscreen;</code><code id="line-229">
</code><code id="line-230"><strong>  [LenientSetter]</strong>
</code><code id="line-231">  readonly attribute boolean fullscreenEnabled;
};</code>
</pre>

<p>In these cases, an extra sentence is added to the description of the property. E.g</p>

<p><em>Although this property is read-only, it will not throw if it is modified (even in strict mode); the setter is a no-operation and it will be ignored.</em></p>

<h3 id="New_objects_or_references"><span>New objects or references</span></h3>

<p><span>The return value of a property can be either a copy of an internal object, a newly created synthetic object, or a reference to an internal object.</span></p>

<p><span>Basic objects with types like {{jsxref("String")}} (being an IDL <code>DOMString</code>, or other), {{jsxref("Number")}} (being an IDL <code>byte</code>, <code>octet</code>, <code>unsigned int</code>, or other), and {{jsxref("Boolean")}} are always copied and nothing special has to be noted about them (it is natural behavior expected by a JavaScript developer.)</span></p>

<p><span>For interface objects, the default is to return a <em>reference</em> to the internal object. This has to be mentioned both in the short description in the interface page, and in the description in the specific sub-pages.</span></p>

<div class="note">
<p><span><strong>Note:</strong> The keyword <code>readonly</code> used with a property returning an object applies to the <u>reference</u> (the internal object cannot be changed.) The properties of the returned object can be changed, even if they are marked as read-only in the relevant interface.</span></p>
</div>

<p>Sometimes an API must return a <em>new</em> object, or a <em>copy</em> of an internal one. This case is indicated in the WebIDL using the <code>[NewObject]</code> annotation.</p>

<pre class="syntaxbox" lang="en"><strong>[NewObject]</strong>
   readonly attribute TimeRanges buffered;</pre>

<p>In this case, each call to <code>buffered</code> returns a different object: changing it will not change the internal value, and a change in the internal value will not affect each object instance. In the documentation, we will mark it by using the adjective <em>new</em> next to object:</p>

<p><em>The <strong><code>HTMLMediaElement.buffered</code></strong> read-only property returns a new \{{domxref("TimeRanges")}} object that… </em></p>

<p>and</p>

<dl>
 <dt><em>\{{domxref("HTMLMediaElement.buffered")}}\{{readonlyinline}}</em></dt>
 <dd><em>Returns a new \{{domxref("TimeRanges")}} object that …</em></dd>
</dl>

<p>In the case of a reference to a collection object (like <code>HTMLCollection</code>, <code>HTMLFormElementsCollection</code>, or <code>HTMLOptionsCollection</code>, always without <code>[NewObject]</code>), we make it explicit that changes to the underlying object will be available via the returned reference. To mark this, we qualify the collection as a <strong>live </strong><code>HTMLCollection</code><strong> </strong>(or <code>HTMLFormElementsCollections</code>, or <code>HTMLOptionsCollection</code>), both in the interface description and in the subpage.</p>

<p>E.g.</p>

<dl>
 <dt>\{{domxref("HTMLFormElement.elements")}}\{{readonlyinline}}</dt>
 <dd>Returns a live \{{domxref("HTMLFormControlsCollection")}} containing…</dd>
</dl>

<h3 id="Availability_in_workers"><span>Availability in workers</span></h3>

<p>Individual property availability in workers is also found in the WebIDL. For a property, the default is the same availability as the <code>interface</code> (that is available to {{domxref('Window')}} context only if nothing special is marked) or as the <code>partial interface</code> it is defined in.</p>

<p>For documentation, the subpage must contain a sentence indicating if it is available or not in Web workers, right before the "Syntax" section.</p>

<h3 id="Preferences_2">Preferences</h3>

<div class="note">
<p>This information is specific to Gecko and should only be used in the Browser compatibility section.</p>
</div>

<p>In Gecko, the availability of some properties may be controlled by a preference. This is marked in the WebIDL too.</p>

<pre class="syntaxbox" lang="en"><strong>[Pref="media.webvtt.enabled"]</strong>
    readonly attribute TextTrackList? textTracks;</pre>

<p><span>Here <code>media.webvtt.enabled</code> controls the <code>textTracks</code> property. </span></p>

<div class="note">
<p><span>The default value of the preference is not available directly in the WebIDL (it can be different from one product using Gecko to another).</span></p>
</div>

<h2 id="Methods">Methods</h2>

<p>You can recognize the definition of a method by the presence of parentheses after the name.</p>

<h3 id="Name_of_the_method">Name of the method</h3>

<pre class="syntaxbox" lang="en">DOMString <strong>canPlayType</strong>(DOMString type);</pre>

<p>The name of the method is <code>canPlayType</code>, and we will refer to it as <code>HTMLMediaElement.canPlayType()</code> (with the parentheses that indicate that it is a method) in the docs, as it belongs to the <code>HTMLMediaElement</code> interface. Linking to the page is either done <strong>with</strong> the interface prefix using \{{domxref('HTMLMediaElement.canPlayType()')}}, or <strong>without</strong> the prefix using \{{domxref('HTMLMediaElement.canPlayType', 'canPlayType()')}} when the context is obvious and unambiguous. The parentheses should always be included.</p>

<h3 id="Parameters">Parameters</h3>

<pre class="syntaxbox">TextTrack addTextTrack(TextTrackKind <strong>kind</strong>,
                       optional DOMString <strong>label</strong> = "",
                       optional DOMString <strong>language</strong> = "");</pre>

<p>The parameters of a method are listed in the Syntax section of the method sub-page. They are listed in the WebIDL in order, between the parenthesis, as a comma-separated list. Each parameter has a name (indicated above) and a type (e.g. a <code>'?'</code> means that the <code>null</code> value is valid.) If marked <code>optional</code>, the parameter is optional to include in a method call and must have the \{{OptionalInline}} flag included when it is listed in the Syntax section. The parameter's default value is listed after the equality sign (<code>'='</code>).</p>

<h3 id="Type_of_the_return_value">Type of the return value</h3>

<pre class="syntaxbox" lang="en">DOMString <strong>canPlayType</strong>(DOMString type);</pre>

<p><span>The return value type is indicated first inside the parentheses — in the above case the value is an object of type <code>DOMString</code>. if followed by a question mark (<code>'?'</code>), a value of <code>null</code> can be returned too, and the documentation must explain <em>when</em> this may happen. If no question mark is present, like here,  the return value can't be <code>null</code>.</span></p>

<p><span>The keyword <code>void</code> means that there is no return value. It is not a return value type. If the WebIDL entry reads <code>void</code>, the <em>Return value</em> section in the docs should contain only a simple <em>None</em>.</span></p>

<h3 id="Throwing_exceptions_2">Throwing exceptions</h3>

<pre class="syntaxbox" lang="en"><strong>[Throws]</strong>
   void fastSeek(double time);</pre>

<p><span>Some methods can throw exceptions. This is marked using the <code>[Throws]</code> annotation. When this happens, the Syntax section of the method page <em>must</em> have an Exceptions subsection. The list of exceptions and the conditions to have them thrown are listed, as textual information, in the specification of that API.</span></p>

<p><span>Note that some exceptions are not explicitly marked but are defined by the JavaScript bindings. <a href="https://heycam.github.io/webidl/#es-enumeration">Trying to set an illegal enumerated value</a> (mapped to a JavaScript {{jsxref('String')}}) as a parameter will raise a {{exception('TypeError')}} exception. This must be documented, but it is only implicitly marked in the WebIDL document.</span></p>

<p><span>Have a look at one of these <a href="/en-US/docs/Web/API/SubtleCrypto/importKey#Exceptions"><em>Exceptions</em> sections</a>.</span></p>

<h3 id="Availability_in_workers_2"><span>Availability in workers</span></h3>

<p>Individual method availability in workers is also found in the WebIDL. For a method, the default is the same availability as the <code>interface</code> (that is available to {{domxref('Window')}} context only if nothing special is marked) or as the <code>partial interface</code> it is defined it.</p>

<p>For the documentation, the sub-page must contain a sentence indicating if it is available in Web workers, right before the Syntax section.</p>

<h3 id="Preferences_3">Preferences</h3>

<div class="note">
<p><strong>Note:</strong> this information is specific to Gecko and should only be used in the Browser compatibility section.</p>
</div>

<p>In Gecko, the availability of some properties may be controlled by a preference. This is marked in the WebIDL too.</p>

<pre class="syntaxbox" lang="en"><strong>[Pref="media.webvtt.enabled"]</strong>
   TextTrack addTextTrack(TextTrackKind kind,
                          optional DOMString label = "",
                          optional DOMString language = "");</pre>

<p><span>Here <code>media.webvtt.enabled</code> controls the <code>addTextTrack()</code> method. </span></p>

<div class="note">
<p><span><strong>Note:</strong> The default value of the preference is not available directly in the WebIDL (it can be different from one product using Gecko to another.)</span></p>
</div>

<h3 id="sect1"></h3>

<h2 id="Special_methods">Special methods</h2>

<p>Some methods are not listed as regular methods in WebIDL but instead as special keywords, which translate to specific standard JavaScript methods.</p>

<h3 id="toString_and_toJSON">toString() and toJSON()</h3>

<p>A stringifier specifies how an object based on an interface is resolved in contexts expecting a string. (See <a href="Stringifiers">stringifiers</a>.) Additionaly, the keyword is mapped to <code>toString()</code> and defined as:</p>

<pre class="syntaxbox"><strong>stringifier;</strong></pre>

<p>The <code>toString()</code> method is listed just like any other method of the interface and has its own sub-page (E.g. {{domxref("Range.toString()")}})</p>

<p>A jsonifier is mapped to <code>toJSON()</code> and defined as:</p>

<pre class="syntaxbox" lang="en"><strong>jsonifier;</strong> <span>// Gecko version</span><strong><span>
serializer;</span></strong><span> // Standard version</span>
</pre>

<p>The <code>toJSON()</code> method is listed just like any other method of the interface and has its own sub-page (E.g. {{domxref("Performance.toJSON()")}})</p>

<div class="note">
<p><strong>Note:</strong> the WebIDL specification uses <code>serializer</code> instead of <code>jsonifier</code>. This is not used in Gecko — only the non-standard likely early proposal <code>jsonifier</code> is found in mozilla-central.</p>
</div>

<h3 id="Iterator-like_methods">Iterator-like methods</h3>

<p>An interface may be defined as <em>iterable</em>, meaning that it will have the following methods: <code>entries()</code>, <code>keys()</code>, <code>values()</code> and <code>forEach()</code>. They also supports the use of {{jsxref("Statements/for...of", "for...of")}} on an object implementing this interface.</p>

<p>There are two kinds of iteration possible: the <em>value iterator</em> and the <em>pair iterator.</em></p>

<h4 id="Value_iterator">Value iterator</h4>

<pre class="syntaxbox">iterable&lt;<em>valueType</em>&gt;</pre>

<p>The iterator will iterate over values of type <em>valueType</em>. The generated methods will be:</p>

<ul>
 <li><code>entries()</code>, which returns an {{jsxref('iterator')}} on the indexes (that are <code>unsigned long</code>).</li>
 <li><code>values()</code>, which returns an {{jsxref('iterator')}} on the values.</li>
 <li><code>keys()</code>, which returns an {{jsxref('iterator')}} on the keys, that are its indexes (that are <code>unsigned long</code>). In the case of value iterators, <code>keys()</code> and <code>entries()</code> are identical.</li>
 <li><code>forEach()</code>, which returns an {{jsxref('iterator')}} on the keys that calls a given callback function one for each entry in the list.</li>
</ul>

<p>Such an iterator allows to use the syntax <code>for (var p in object)</code> as a shorthand of <code>for (var p in object.entries())</code>. We add a sentence about it in the interface description.</p>

<div class="note">
<p><strong>Note:</strong> the value pairs to iterate over can be defined in two different ways:</p>

<ol>
 <li>Outside the webidl file, in the prose accompanying it. Such a prose is in the spec and usually starts with: <em>"The <a class="external" href="https://heycam.github.io/webidl/#dfn-values-to-iterate-over">values to iterate over</a>…"</em>.</li>
 <li>In the webidl file, implicitly, if the interface supports indexed properties, that is when the interface has a <code>getter</code> methods with a parameter of type <code>unsigned long</code>.</li>
</ol>
</div>

<h4 id="Pair_iterator">Pair iterator</h4>

<pre class="syntaxbox">iterable&lt;<em>keyType, valueType</em>&gt;</pre>

<p>The iterator will iterate over values of type <em>valueType</em>, with keys of type <em>keyType</em>. The generated methods will be:</p>

<ul>
 <li><code>entries()</code> that returns an {{jsxref('iterator')}} on the indexes (of type <em>keyType</em>). E.g. {{domxref('FormData.entries()')}}</li>
 <li><code>values()</code> that returns an {{jsxref('iterator')}} on the values. E.g. {{domxref('FormData.values()')}}</li>
 <li><code>keys()</code> that returns an {{jsxref('iterator')}} on the keys. E.g. {{domxref('FormData.keys()')}}</li>
 <li>Once {{bug(1216751)}} lands, <code>forEach()</code>.</li>
</ul>

<p>Such an iterator allows to use the syntax <code>for (var p in object)</code> as a shorthand of <code>for (var p in object.entries())</code>. We add a sentence about it in the interface description. E.g. {{domxref('FormData')}}.</p>

<div class="note">
<p><strong>Note:</strong> the value pairs to iterate over are <em>not</em> defined in the webidl file, but in the prose accompanying it. Such a prose is in the spec and usually starts with: <em>"The <a class="external" href="https://heycam.github.io/webidl/#dfn-value-pairs-to-iterate-over">value pairs to iterate over</a>…"</em><br>
 E.g, for {{domxref('FormData')}} you find in the spec: <em>"The <a class="external" href="https://heycam.github.io/webidl/#dfn-value-pairs-to-iterate-over">value pairs to iterate over</a> are the <a href="https://xhr.spec.whatwg.org/#concept-formdata-entry" title="concept-FormData-entry">entries</a> with the key being the <a href="https://xhr.spec.whatwg.org/#concept-formdata-entry-name" title="concept-FormData-entry-name">name</a> and the value the <a href="https://xhr.spec.whatwg.org/#concept-formdata-entry-value" title="concept-FormData-entry-value">value</a>. "</em></p>
</div>

<h3 id="Set-like_methods">Set-like methods</h3>

<p>An interface may be defined as <em>set-like</em>, meaning that it represents an <em>ordered set of values</em> will have the following methods: <code>entries()</code>, <code>keys()</code>,  <code>values()</code>, <code>forEach(),</code> and <code>has()</code> (it also has the <code>size</code> property). They also supports the use of {{jsxref("Statements/for...of", "for...of")}} on an object implementing this interface. The set-like can be prefixed <code>readonly</code> or not. If not read-only, the methods to modify the set are also implemented: <code>add()</code>, <code>clear()</code>, and <code>delete()</code>.</p>

<pre class="syntaxbox">setlike&lt;<em>valueType</em>&gt;</pre>

<p>The generated properties will be:</p>

<ul>
 <li><code>entries()</code> that returns an {{jsxref('iterator')}} on the indexes. E.g. {{domxref('FontFaceSet.entries()')}}.</li>
 <li><code>values()</code> that returns an {{jsxref('iterator')}} on the values. E.g. {{domxref('FontFaceSet.values()')}}.</li>
 <li><code>keys()</code> that returns an {{jsxref('iterator')}} on the keys. E.g. {{domxref('FontFaceSet.keys()')}},</li>
 <li><code>forEach()</code>.</li>
</ul>

<p>In the case, the set-like declaration is not prefixed by read-only, the following methods are also generated:</p>

<ul>
 <li><code>add()</code> that adds an entry. E.g. {{domxref('FontFaceSet.add()')}}.</li>
 <li><code>clear()</code> that empty the set-like. E.g. {{domxref('FontFaceSet.clear()')}}.</li>
 <li><code>delete()</code> that remove an entry. E.g. {{domxref('FontFaceSet.delete()')}}.</li>
</ul>

<p>Such an set interface also allows to use the syntax <code>for (var p in object)</code> as a shorthand of <code>for (var p in object.entries())</code>. We add a sentence about it in the interface description. E.g. {{domxref('FontFaceSet')}}.</p>

<h2 id="Special_Behaviors">Special Behaviors</h2>

<p>Some IDL members indicate special behaviors that should be noted on appropriate pages.</p>

<h3 id="Stringifiers">Stringifiers</h3>

<p>In addition to adding the <code>toString()</code> method to an interface as described in <a href="#toString_and_toJSON">toString() and toJSON()</a>, stringifiers also indicate that an object instance, when used as a string, returns a <code>DOMString</code> other than the default. (The default is usually a JSON representation of the object). Exactly how depends on the way it is specified in the IDL. Regardless of the how, the non-default behavior should be described on the interface page.</p>

<p>When the <code>stringifier</code> keyword accompanies an attribute name, referencing the object name has the same result as referencing the attribute name. Consider the following IDL:</p>

<pre class="syntaxbox" lang="en">interface InterfaceIdentifier {
  stringifier attribute DOMString DOMString name;
};</pre>

<p>For a class based on this interface, the following lines of code below are equivalent. The behavior should be noted on the property page in addition to the interface page.</p>

<pre class="js" lang="en">console.log(interfaceIdentifier);
console.log(interfaceIdentifier.name);
</pre>

<p>When the <code>stringifier</code> keyword is used by itself, an object of the interface may be used as above, but the behavior is defined in source code.</p>

<pre class="syntaxbox" lang="en">interface InterfaceIdentifier {
  stringifier;
};</pre>

<p>To learn what an interface reference actually does, refer to the interface's spec or experiment with the interface to determine its output.</p>

<h2 id="Constructors">Constructors</h2>

<p>Constructors are a little bit hidden in WebIDL: they are listed as annotations of the main interface.</p>

<h3 id="Unnamed_constructors">Unnamed constructors</h3>

<p>This is the most common case for constructors. The constructor of a given interface A, can be used as <code>a = new A(<em>parameters</em>);</code></p>

<pre class="syntaxbox" lang="en">[<strong>Constructor</strong>, Func="MessageChannel::Enabled",
  Exposed=(Window,Worker)]
    interface MessageChannel {…};</pre>

<p><span>A constructor with the same interface is defined using the <code>Constructor</code> annotation on the interface. There can be parenthesis and a list of parameters or not (like in the above example.) We document all the unnamed constructors on a sub-page — for example the above is given the slug <em>Web/API/MessageChannel/MessageChannel</em> and the title <code>MessageChannel()</code>.</span></p>

<p><span>Another example of an unnamed constructor, with parameters:</span></p>

<pre class="syntaxbox" lang="en">[<strong>Constructor</strong>(DOMString type, optional MessageEventInit eventInitDict),
 Exposed=(Window,Worker,System)]
   interface MessageEvent : Event {…};</pre>

<p>There can also be several unnamed constructors, differing by their parameter lists. All syntax is documented in one single sub-page.</p>

<pre class="syntaxbox" lang="en">[<strong>Constructor</strong>(DOMString url, URL base),
 <strong>Constructor</strong>(DOMString url, optional DOMString base),
 Exposed=(Window,Worker)]
    interface URL {};</pre>

<h3 id="Named_constructors">Named constructors</h3>

<pre class="syntaxbox" lang="en">[<strong>NamedConstructor</strong>=Image(optional unsigned long width, optional unsigned long height)]
    interface HTMLImageElement : HTMLElement {…</pre>

<p><span>A named constructor is a constructor that has a different name than that of its interface. For example<code> new Image(…)</code> creates a new <code>HTMLImageElement</code> object. They are defined in the WebIDL using the <code>NamedConstructor</code> annotation on the interface, followed by the name of the constructor after the equality sign (<code>'='</code>) and the parameter inside the parenthesis, in the same format as you'll see for methods.</span></p>

<p><span>There can be several named constructors for a specific interface, but this is extremely rare; in such a case we include one sub-page per name.</span></p>

<h3 id="New_constructor_syntax"><span>New constructor syntax</span></h3>

<p><span>As of September 2019, WebIDL constructor syntax was updated. </span>Constructor syntax no longer involves an extended attribute on the interface:</p>

<pre>[Constructor(DOMString str)]
    interface MyInterface {
      ...
};</pre>

<p>New specs instead use a method-like syntax named <code>constructor</code> with no explicitly-defined return type, written like so:</p>

<pre>interface MyInterface {
  constructor(DOMString str);
};</pre>

<p>This means extended attributes can now be specified on the constructor, and it is no longer assumed that all constructors throw. If a constructor does throw, <code>[Throws]</code> will be used to indicate that:</p>

<pre>interface MyInterface {
  [Throws] constructor();
};</pre>

<p>It is unlikely that <em>all</em> specs will be updated to use the new syntax, so you'll probably encounter both out in the wild. We will therefore continue to cover both types of syntax here.</p>

<h3 id="Availability_in_workers_3"><span>Availability in workers</span></h3>

<p>Constructors have the same availability as the interface, or partial interface, they are defined on. The sub-page provides this information in the same way as for a method.</p>

<h3 id="Preferences_4">Preferences</h3>

<p>Constructors are controlled by the same preference as the interface, or partial interface, they are defined on. The sub-page provides this information in the same way as for a method.</p>
